import { calcWinner } from '../assets/utils';
export default {

  namespace: 'con',

  state: {
    playerValue: 'x',// x or o
    records: [new Array(9).fill(null)],
    step: 0,
    winner: '',
    coordinate: []
  },

  subscriptions: {
    setup({ dispatch, history }) {  // eslint-disable-line
      history.listen(location => {
        if (location.pathname === '/con') {
          dispatch({
            type: 'play'
          })
        }
      })
    },
  },

  effects: {
    // *isComplete() {

    // }
    *fetch({ payload }, { call, put, select }) {  // eslint-disable-line
      const { step: newStep, records: newRecords, coordinate: newCoordinate } = payload
      const { step: oldStep, records: oldRecords, coordinate: oldCoordinate } = yield select((state) => state.con);
      const func = (item, stepNum) => {
        let temp = JSON.parse(JSON.stringify(item));
        temp = newStep === oldRecords.length ? temp : temp.slice(0, stepNum)
        return temp;
      }
      let oldCd = func(oldCoordinate, oldStep)
      let oldRc = func(oldRecords, newStep)
      let tmp = JSON.parse(JSON.stringify([newRecords]))
      const winner = calcWinner(...tmp)
      yield put({
        type: 'updateState', payload: {
          records: oldRc.concat(tmp),
          step: newStep,
          playerValue: oldStep % 2 === 0 ? 'o' : 'x',
          winner,
          coordinate: oldCd.concat({ step: newStep, coordinate: newCoordinate })
        }
      });
    },
  },

  reducers: {
    updateState(state, { payload }) {
      return {
        ...state,
        ...payload
      };
    },
    reset(state) {
      return {
        ...state,
        playerValue: 'x',// x or o
        records: [new Array(9).fill(null)],
        step: 0,
        winner: '',
        coordinate: []
      }
    },
    goBack(state, { payload }) {
      const { step, playerValue } = payload;
      const { records } = state;
      return {
        ...state,
        winner: calcWinner(records[step]),
        playerValue,
        step
      }
    }
  },

};
