import React from 'react';
import { connect } from 'dva';
import styles from './board.css';
import Square from '../components/Square';
import { Button } from 'antd';

function Board({ dispatch, con }) {
  const { playerValue, records, step, winner } = con;
  const mapSquare = (item, index, row) => {
    const play = (index, row) => {
      if (winner === '') {
        const handlerChange = (arr) => {
          dispatch({
            type: 'con/fetch',
            payload: {
              coordinate: `[${row}, ${index}]`,
              records: arr,
              step: step + 1
            }
          })
        }
        let newArr = JSON.parse(JSON.stringify(records));
        const latestMove = newArr[step];
        switch (row) {
          case 0:
            if (latestMove[index] !== null) {
              alert('这个位置被占啦，换个地方吧~')
            } else {
              newArr[step].splice(index, 1, playerValue);
              handlerChange(newArr[step]);
            }
            break;
          case 1:
            if (latestMove[index + 3] !== null) {
              alert('这个位置被占啦，换个地方吧~')
            } else {
              newArr[step].splice(index + 3, 1, playerValue);
              handlerChange(newArr[step]);
            }
            break;
          case 2:
            if (latestMove[index + 6] !== null) {
              alert('这个位置被占啦，换个地方吧~')
            } else {
              newArr[step].splice(index + 6, 1, playerValue);
              handlerChange(newArr[step]);
            }
            break;
          default:
            break;
        }
      } else {
        alert('你已经赢了，再来一局吧~')
        return;
      }

    }
    return <Square key={index} value={item} onClick={() => play(index, row)} />
  }
  const reset = () => {
    dispatch({type: 'con/reset'})
  }
  const chessArr = records[step];
  return (
    <div className={styles.board}>
      <div className={styles.normal}>
        <div className={styles.header}>the next player is: {playerValue}</div>
        <div>{chessArr.slice(0, 3).map((item, index) => mapSquare(item, index, 0))}</div>
        <div>{chessArr.slice(3, 6).map((item, index) => mapSquare(item, index, 1))}</div>
        <div>{chessArr.slice(6, 9).map((item, index) => mapSquare(item, index, 2))}</div>
        <Button onClick={() => reset()}>重新开始</Button>
        <div>the winner is: {winner}</div>
      </div>
    </div>
  );
}

// IndexPage.propTypes = {
// };

export default connect(({ con }) => ({ con }))(Board);
