import React from 'react';
import { connect } from 'dva';
import Board from './Board';
import styles from './board.css';
import { Button } from 'antd';
import RecordTable from '../components/RecordTable';


const Index = ({ dispatch, con }) => {
    const { coordinate } = con;
    const recall = (records, index) => {
        let next = index % 2 === 0 ? 'o' : 'x';
        dispatch({
            type: 'con/goBack',
            payload: {
                step: index + 1,
                playerValue: next
            }
        })
    }
    const column = [
        {
            title: '步数',
            key: 'step',
            dataIndex: 'step',
            render: (text, records, index) => <Button className={styles.step} onClick={() => recall(records, index)}>{text}</Button>
        },
        {
            title: '坐标',
            key: 'coordinate',
            dataIndex: 'coordinate'
        }
    ]
    return (
        <div style={{width: '100%',display: 'inline-block'}}>
            <Board />
            <div className={styles.table}>
                <RecordTable column={column} data={coordinate} />
            </div>
        </div>
    )
}
export default connect(({ con }) => ({ con }))(Index)
